/*
 * File Archive Library
 * Copyright (C) 2000-2001 Patrizio Bruno <patrizio@dada.it>
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *    Read the file LICENSE for more.
 *
 */

/*
 * $Log: utils.h,v $
 * Revision 3.1  2001/06/06 12:03:42  rusty
 * *** empty log message ***
 *
 * Revision 3.0  2001/05/31 11:34:20  rusty
 *
 * new version
 *
 * Revision 1.12  2001/05/28 11:12:19  rusty
 *
 * struct stat entry_info has been replaced by struct far_stat
 * a portable version of the stat structure
 *
 * Revision 1.11  2001/05/25 15:28:35  rusty
 *
 * fixed the struct dirent handling on solaris
 *
 * Revision 1.10  2001/05/25 15:03:55  rusty
 *
 * sun dirent support
 *
 * Revision 1.9  2001/05/24 16:59:33  rusty
 *
 * alphasort's wrapper
 *
 * Revision 1.8  2001/05/24 16:48:16  rusty
 *
 * scandir wrapper for systems that do not natively support this BSD function
 *
 * Revision 1.7  2001/05/21 12:16:45  rusty
 *
 * added a md5 checksum for the whole archive
 *
 * Revision 1.6  2001/05/21 11:06:31  rusty
 *
 * byte ordering fixed
 *
 * Revision 1.5  2001/05/16 16:08:17  rusty
 * *** empty log message ***
 *
 * Revision 1.4  2001/05/16 11:04:57  rusty
 *
 * some debug code removed
 * added a function displaying the internal version of the library: far_version() in utils.c
 *
 * Revision 1.3  2000/09/21 11:27:44  rusty
 *
 * bug fixes
 *
 * Revision 1.2  2000/09/20 17:43:07  rusty
 *
 * why checksums of big files seem to be corrupted?
 *
 * Revision 1.1  2000/09/20 14:10:22  rusty
 *
 * First working (basic) release
 *
 */

#ifndef	_UTILS_H_
#define	_UTILS_H_

#ifndef	FALSE
#	define	FALSE	0
#endif
#ifndef	TRUE
#	define	TRUE	1
#endif

int is_adir(const char *);
int far_checksum(FAR_INFO *, unsigned char *);
void make_list(char *, char *, char *ilist[], int);
int strcount(char *, char *);
char *strjoin(char **, int, char *);
char *far_version(void);
int far_printf(FILE *, char *, ...);
void far_byteorder_conv(FAR_INFO *);
void far_byteorder_backconv(FAR_INFO *);
u_int64_t far_conv64(u_int64_t);
int far_file_cksum(unsigned char *, size_t);
void *memdup(void *, size_t);
int far_alphasort(const struct dirent **, const struct dirent **);
struct dirent *far_dirdup(struct dirent *);
int make_path(char *, mode_t);
int far_scandir(const char *, struct dirent ***,
	int (*)(const struct dirent *),
	int (*)(const struct dirent **, const struct dirent **));

#endif	/* _UTILS_H_ */
